using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Salesmen
{
	/// <summary>
	/// Summary description for salesmenForm
	/// </summary>
	public class salesmenForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel controlPanel;
		private System.Windows.Forms.LinkLabel exitProgramLabel;
		private System.Windows.Forms.LinkLabel clearSidesLabel;
		private System.Windows.Forms.LinkLabel loadSidesLabel;
		private System.Windows.Forms.LinkLabel getBackLabel;
		private System.Windows.Forms.LinkLabel getOverLabel;
		private System.Windows.Forms.Panel filePanel;
		private System.Windows.Forms.Label titleLabel;
		private System.Windows.Forms.Button openFileButton;
		private System.Windows.Forms.TextBox fileBox;
		private System.Windows.Forms.Panel timePanel;
		private System.Windows.Forms.Label errorLabel;
		private System.Windows.Forms.Label timeElapsedLabel;
		private System.Windows.Forms.Label timeTextLabel;
		private System.Windows.Forms.ListBox rightSideList;
		private System.Windows.Forms.ListBox leftSideList;
		private System.Windows.Forms.OpenFileDialog openFileDialog;
		private System.Windows.Forms.ErrorProvider myErrorProvider;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public salesmenForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.controlPanel = new System.Windows.Forms.Panel();
			this.exitProgramLabel = new System.Windows.Forms.LinkLabel();
			this.clearSidesLabel = new System.Windows.Forms.LinkLabel();
			this.loadSidesLabel = new System.Windows.Forms.LinkLabel();
			this.getBackLabel = new System.Windows.Forms.LinkLabel();
			this.getOverLabel = new System.Windows.Forms.LinkLabel();
			this.filePanel = new System.Windows.Forms.Panel();
			this.titleLabel = new System.Windows.Forms.Label();
			this.openFileButton = new System.Windows.Forms.Button();
			this.fileBox = new System.Windows.Forms.TextBox();
			this.timePanel = new System.Windows.Forms.Panel();
			this.errorLabel = new System.Windows.Forms.Label();
			this.timeElapsedLabel = new System.Windows.Forms.Label();
			this.timeTextLabel = new System.Windows.Forms.Label();
			this.rightSideList = new System.Windows.Forms.ListBox();
			this.leftSideList = new System.Windows.Forms.ListBox();
			this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
			this.myErrorProvider = new System.Windows.Forms.ErrorProvider();
			this.controlPanel.SuspendLayout();
			this.filePanel.SuspendLayout();
			this.timePanel.SuspendLayout();
			this.SuspendLayout();
			// 
			// controlPanel
			// 
			this.controlPanel.BackColor = System.Drawing.Color.Gainsboro;
			this.controlPanel.Controls.Add(this.exitProgramLabel);
			this.controlPanel.Controls.Add(this.clearSidesLabel);
			this.controlPanel.Controls.Add(this.loadSidesLabel);
			this.controlPanel.Controls.Add(this.getBackLabel);
			this.controlPanel.Controls.Add(this.getOverLabel);
			this.controlPanel.Location = new System.Drawing.Point(0, 96);
			this.controlPanel.Name = "controlPanel";
			this.controlPanel.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.controlPanel.Size = new System.Drawing.Size(160, 264);
			this.controlPanel.TabIndex = 1;
			// 
			// exitProgramLabel
			// 
			this.exitProgramLabel.ActiveLinkColor = System.Drawing.Color.DarkGray;
			this.exitProgramLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.exitProgramLabel.LinkBehavior = System.Windows.Forms.LinkBehavior.HoverUnderline;
			this.exitProgramLabel.LinkColor = System.Drawing.Color.Black;
			this.exitProgramLabel.Location = new System.Drawing.Point(24, 136);
			this.exitProgramLabel.Name = "exitProgramLabel";
			this.exitProgramLabel.Size = new System.Drawing.Size(120, 23);
			this.exitProgramLabel.TabIndex = 6;
			this.exitProgramLabel.TabStop = true;
			this.exitProgramLabel.Text = "Exit program";
			this.exitProgramLabel.VisitedLinkColor = System.Drawing.Color.Black;
			this.exitProgramLabel.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.exitProgramLabel_LinkClicked);
			// 
			// clearSidesLabel
			// 
			this.clearSidesLabel.ActiveLinkColor = System.Drawing.Color.DarkGray;
			this.clearSidesLabel.Enabled = false;
			this.clearSidesLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.clearSidesLabel.LinkBehavior = System.Windows.Forms.LinkBehavior.HoverUnderline;
			this.clearSidesLabel.LinkColor = System.Drawing.Color.Black;
			this.clearSidesLabel.Location = new System.Drawing.Point(24, 64);
			this.clearSidesLabel.Name = "clearSidesLabel";
			this.clearSidesLabel.Size = new System.Drawing.Size(120, 23);
			this.clearSidesLabel.TabIndex = 3;
			this.clearSidesLabel.TabStop = true;
			this.clearSidesLabel.Text = "Clear sides";
			this.clearSidesLabel.VisitedLinkColor = System.Drawing.Color.Black;
			this.clearSidesLabel.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.clearSidesLabel_LinkClicked);
			// 
			// loadSidesLabel
			// 
			this.loadSidesLabel.ActiveLinkColor = System.Drawing.Color.DarkGray;
			this.loadSidesLabel.Enabled = false;
			this.loadSidesLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.loadSidesLabel.LinkBehavior = System.Windows.Forms.LinkBehavior.HoverUnderline;
			this.loadSidesLabel.LinkColor = System.Drawing.Color.Black;
			this.loadSidesLabel.Location = new System.Drawing.Point(24, 40);
			this.loadSidesLabel.Name = "loadSidesLabel";
			this.loadSidesLabel.Size = new System.Drawing.Size(120, 23);
			this.loadSidesLabel.TabIndex = 2;
			this.loadSidesLabel.TabStop = true;
			this.loadSidesLabel.Text = "Load sides";
			this.loadSidesLabel.VisitedLinkColor = System.Drawing.Color.Black;
			this.loadSidesLabel.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.loadSidesLabel_LinkClicked);
			// 
			// getBackLabel
			// 
			this.getBackLabel.ActiveLinkColor = System.Drawing.Color.DarkGray;
			this.getBackLabel.Enabled = false;
			this.getBackLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.getBackLabel.LinkBehavior = System.Windows.Forms.LinkBehavior.HoverUnderline;
			this.getBackLabel.LinkColor = System.Drawing.Color.Black;
			this.getBackLabel.Location = new System.Drawing.Point(24, 112);
			this.getBackLabel.Name = "getBackLabel";
			this.getBackLabel.Size = new System.Drawing.Size(120, 23);
			this.getBackLabel.TabIndex = 5;
			this.getBackLabel.TabStop = true;
			this.getBackLabel.Text = "Get back";
			this.getBackLabel.VisitedLinkColor = System.Drawing.Color.Black;
			this.getBackLabel.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.getBackLabel_LinkClicked);
			// 
			// getOverLabel
			// 
			this.getOverLabel.ActiveLinkColor = System.Drawing.Color.DarkGray;
			this.getOverLabel.Enabled = false;
			this.getOverLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.getOverLabel.LinkBehavior = System.Windows.Forms.LinkBehavior.HoverUnderline;
			this.getOverLabel.LinkColor = System.Drawing.Color.Black;
			this.getOverLabel.Location = new System.Drawing.Point(24, 88);
			this.getOverLabel.Name = "getOverLabel";
			this.getOverLabel.Size = new System.Drawing.Size(112, 23);
			this.getOverLabel.TabIndex = 4;
			this.getOverLabel.TabStop = true;
			this.getOverLabel.Text = "Get over";
			this.getOverLabel.VisitedLinkColor = System.Drawing.Color.Black;
			this.getOverLabel.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.getOverLabel_LinkClicked);
			// 
			// filePanel
			// 
			this.filePanel.BackColor = System.Drawing.Color.Navy;
			this.filePanel.Controls.Add(this.titleLabel);
			this.filePanel.Controls.Add(this.openFileButton);
			this.filePanel.Controls.Add(this.fileBox);
			this.filePanel.Location = new System.Drawing.Point(0, 0);
			this.filePanel.Name = "filePanel";
			this.filePanel.Size = new System.Drawing.Size(580, 100);
			this.filePanel.TabIndex = 2;
			// 
			// titleLabel
			// 
			this.titleLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 14F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.titleLabel.ForeColor = System.Drawing.Color.White;
			this.titleLabel.Location = new System.Drawing.Point(24, 40);
			this.titleLabel.Name = "titleLabel";
			this.titleLabel.Size = new System.Drawing.Size(96, 24);
			this.titleLabel.TabIndex = 0;
			this.titleLabel.Text = "Salesmen";
			// 
			// openFileButton
			// 
			this.openFileButton.BackColor = System.Drawing.SystemColors.Control;
			this.openFileButton.ForeColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.openFileButton.Location = new System.Drawing.Point(456, 40);
			this.openFileButton.Name = "openFileButton";
			this.openFileButton.Size = new System.Drawing.Size(80, 23);
			this.openFileButton.TabIndex = 1;
			this.openFileButton.Text = "Open file";
			this.openFileButton.Click += new System.EventHandler(this.openFileButton_Click);
			// 
			// fileBox
			// 
			this.fileBox.AllowDrop = true;
			this.fileBox.Location = new System.Drawing.Point(200, 40);
			this.fileBox.Name = "fileBox";
			this.fileBox.Size = new System.Drawing.Size(248, 20);
			this.fileBox.TabIndex = 0;
			this.fileBox.Text = "";
			// 
			// timePanel
			// 
			this.timePanel.BackColor = System.Drawing.Color.Navy;
			this.timePanel.Controls.Add(this.errorLabel);
			this.timePanel.Controls.Add(this.timeElapsedLabel);
			this.timePanel.Controls.Add(this.timeTextLabel);
			this.timePanel.Location = new System.Drawing.Point(0, 360);
			this.timePanel.Name = "timePanel";
			this.timePanel.Size = new System.Drawing.Size(580, 50);
			this.timePanel.TabIndex = 3;
			// 
			// errorLabel
			// 
			this.errorLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.errorLabel.ForeColor = System.Drawing.Color.White;
			this.errorLabel.Location = new System.Drawing.Point(344, 16);
			this.errorLabel.Name = "errorLabel";
			this.errorLabel.Size = new System.Drawing.Size(40, 16);
			this.errorLabel.TabIndex = 0;
			this.errorLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// timeElapsedLabel
			// 
			this.timeElapsedLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.timeElapsedLabel.ForeColor = System.Drawing.Color.White;
			this.timeElapsedLabel.Location = new System.Drawing.Point(512, 16);
			this.timeElapsedLabel.Name = "timeElapsedLabel";
			this.timeElapsedLabel.Size = new System.Drawing.Size(32, 16);
			this.timeElapsedLabel.TabIndex = 0;
			this.timeElapsedLabel.Text = "0";
			this.timeElapsedLabel.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// timeTextLabel
			// 
			this.timeTextLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.timeTextLabel.ForeColor = System.Drawing.Color.White;
			this.timeTextLabel.Location = new System.Drawing.Point(408, 16);
			this.timeTextLabel.Name = "timeTextLabel";
			this.timeTextLabel.Size = new System.Drawing.Size(96, 16);
			this.timeTextLabel.TabIndex = 0;
			this.timeTextLabel.Text = "Time elapsed:";
			this.timeTextLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// rightSideList
			// 
			this.rightSideList.Enabled = false;
			this.rightSideList.Location = new System.Drawing.Point(384, 136);
			this.rightSideList.MultiColumn = true;
			this.rightSideList.Name = "rightSideList";
			this.rightSideList.SelectionMode = System.Windows.Forms.SelectionMode.MultiExtended;
			this.rightSideList.Size = new System.Drawing.Size(146, 186);
			this.rightSideList.Sorted = true;
			this.rightSideList.TabIndex = 10;
			this.rightSideList.SelectedIndexChanged += new System.EventHandler(this.rightSideList_SelectedIndexChanged);
			// 
			// leftSideList
			// 
			this.leftSideList.ColumnWidth = 80;
			this.leftSideList.DisplayMember = "String*, String*";
			this.leftSideList.Enabled = false;
			this.leftSideList.Location = new System.Drawing.Point(200, 136);
			this.leftSideList.MultiColumn = true;
			this.leftSideList.Name = "leftSideList";
			this.leftSideList.SelectionMode = System.Windows.Forms.SelectionMode.MultiExtended;
			this.leftSideList.Size = new System.Drawing.Size(146, 186);
			this.leftSideList.Sorted = true;
			this.leftSideList.TabIndex = 9;
			this.leftSideList.SelectedIndexChanged += new System.EventHandler(this.leftSideList_SelectedIndexChanged);
			// 
			// openFileDialog
			// 
			this.openFileDialog.Filter = "All files|*.*";
			this.openFileDialog.Title = "Open file...";
			// 
			// myErrorProvider
			// 
			this.myErrorProvider.ContainerControl = this;
			// 
			// salesmenForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.Color.WhiteSmoke;
			this.ClientSize = new System.Drawing.Size(572, 406);
			this.Controls.Add(this.rightSideList);
			this.Controls.Add(this.leftSideList);
			this.Controls.Add(this.timePanel);
			this.Controls.Add(this.filePanel);
			this.Controls.Add(this.controlPanel);
			this.MaximizeBox = false;
			this.MaximumSize = new System.Drawing.Size(580, 440);
			this.MinimumSize = new System.Drawing.Size(580, 440);
			this.Name = "salesmenForm";
			this.Text = "Salesmen on the bridge - Kroly Pfaff";
			this.controlPanel.ResumeLayout(false);
			this.filePanel.ResumeLayout(false);
			this.timePanel.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		/// 

		private int leftSelectable  = 2;
		private int rightSelectable = 1;
		// example can be implemented with more selectable salesmen

		[STAThread]
		static void Main() 
		{
			Application.Run(new salesmenForm());
		}

		private void travelSalesmen(System.Windows.Forms.ListBox fromListBox, System.Windows.Forms.ListBox toListBox)
		{
			int myMaxTime = 0;
			for (int i=0; i<fromListBox.SelectedItems.Count; i++)
			{
				// go over selected items and send to the other side
				toListBox.Items.Add(fromListBox.SelectedItems[i]);
				// we increase our timer with the maximum in right side of the items ("name \t time")
				System.String[] tempStr  = fromListBox.SelectedItems[i].ToString().Split("\t".ToCharArray(), 2);
				int actualTime = System.Convert.ToInt32(tempStr[1]);
				// internal maxsearch
				if ( myMaxTime < actualTime )
				{
					myMaxTime = actualTime;
				}
			}
			// add the slowest men's time to the timeElapsedLabel
			timeElapsedLabel.Text = System.Convert.ToString(System.Convert.ToInt32(timeElapsedLabel.Text) + myMaxTime);
			while (fromListBox.SelectedItems.Count > 0)
			{
				// clear selected items from list -> which one is cleared, is no more selected!
				fromListBox.Items.Remove(fromListBox.SelectedItems[0]);
			}
		}

		private void openFileButton_Click(object sender, System.EventArgs e)
		{
			openFileDialog.ShowDialog();
			if ( openFileDialog.FileName != "" )
			{
				// only if a file is really selected
				fileBox.Text = openFileDialog.FileName;
				loadSidesLabel.Enabled = true;
			}
		}

		private void loadSidesLabel_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			try
			{
				leftSideList.Items.Clear();
				rightSideList.Items.Clear();
				timeElapsedLabel.Text = "0";
				System.IO.StreamReader input = new System.IO.StreamReader(fileBox.Text);
				System.String line;
				while ( (line = input.ReadLine()) != null )
			    {
				   leftSideList.Items.Add( line );
			    }
				input.Close();
				// these are only set if there was no error in reading
				myErrorProvider.SetError(errorLabel, "");
				clearSidesLabel.Enabled = true;
				leftSideList.Enabled = true;
			}
			catch
			{
				// it can be something else too, but I don't care :)
				myErrorProvider.SetError(errorLabel, "File read error!");
			}
		}

		private void clearSidesLabel_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			myErrorProvider.SetError(errorLabel, "");
			leftSideList.Items.Clear();
			rightSideList.Items.Clear();
			timeElapsedLabel.Text = "0";
			leftSideList.Enabled = false;
			rightSideList.Enabled = false;
			clearSidesLabel.Enabled = false;
		}

		private void leftSideList_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			// no cheating is possible :)
			if ( leftSideList.SelectedItems.Count == leftSelectable )
			{
				getOverLabel.Enabled = true;
			}
			else
			{
				getOverLabel.Enabled = false;
			}
		}

		private void rightSideList_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			// no cheating is possible :)
			if ( rightSideList.SelectedItems.Count == rightSelectable )
			{
				getBackLabel.Enabled = true;
			}
			else
			{
				getBackLabel.Enabled = false;
			}
		}

		private void getOverLabel_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			try
			{
				travelSalesmen(leftSideList, rightSideList);
				leftSideList.Enabled = false;
				if ( leftSideList.Items.Count == 0 )
				{
					rightSideList.Enabled = false;
					// not a real error... but it was the simpliest thing ever :)
					myErrorProvider.SetError(errorLabel, "Program has been finished.");
				}
				else
				{
					rightSideList.Enabled = true;
				}
			}
			catch
			{
				myErrorProvider.SetError(errorLabel, "Some error occoured. Program may be wrong :)");
			}
		}

		private void getBackLabel_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			try
			{
				travelSalesmen(rightSideList, leftSideList);
				leftSideList.Enabled = true;
				rightSideList.Enabled = false;
			}
			catch
			{
				myErrorProvider.SetError(errorLabel, "Some error occoured. Program may be wrong :)");
			}
		}

		private void exitProgramLabel_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			this.Dispose(true);
		}

	}
}